{-----------------------------------------------------------------------------}
{   Code source  utilis dans la leon 6 du Guide Pratique de
{   la programmation de directshow sous delphi publi par Paul Glagla
{   sur le site http://paul.glagla.free.fr
{
{-----------------------------------------------------------------------------}
unit main;

{-----------------------------------------------------------------------------}
interface

{-----------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,capture, DSPack,directshow9, ExtCtrls;

{-----------------------------------------------------------------------------}
type
  TForm1 = class(TForm)
    preview: TVideoWindow;
    cboxSources: TComboBox;
    CaptureBtn: TBitBtn;
    StopBtn: TBitBtn;
    ActualiserBtn: TBitBtn;
    cbMute: TCheckBox;
    rgtype: TRadioGroup;
    Panel1: TPanel;
    procedure ActualiserBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cboxSourcesChange(Sender: TObject);
    procedure CaptureBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cbMuteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function previsualiser:Boolean;
    function actualiserListe:Boolean;
    function startcapture:Boolean;
    function stopcapture:Boolean;
  end;

{-----------------------------------------------------------------------------}
var
  Form1: TForm1;

{-----------------------------------------------------------------------------}
//ATTENTION: mettez dans la constante fichier un chemin et nom de fichier avi
// adapt  votre disque dur.
const
  fichier:widestring='f:\temp\trucmuche.avi';
{-----------------------------------------------------------------------------}
implementation

{$R *.dfm}

{-----------------------------------------------------------------------------}
procedure TForm1.ActualiserBtnClick(Sender: TObject);
begin
if actualiserListe then previsualiser;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.FormShow(Sender: TObject);
begin
  rgtype.enabled:=true;
  cboxsources.enabled:=true;
  actualiserbtn.enabled:=true;
  capturebtn.enabled:=true;
  stopbtn.enabled:=false;
if actualiserListe then previsualiser;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.cboxSourcesChange(Sender: TObject);
begin
previsualiser;
end;
{-----------------------------------------------------------------------------}
procedure TForm1.CaptureBtnClick(Sender: TObject);
begin
if startcapture then panel1.color:=clred;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.StopBtnClick(Sender: TObject);
begin
if stopcapture then panel1.color:=clBtnFace;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
capturemodule.CaptureGraph.Stop;
end;

{-----------------------------------------------------------------------------}
function TForm1.previsualiser:Boolean;
begin
result:=false;
with capturemodule do begin
try
  capturegraph.ClearGraph;
  if capturegraph.Active=false then  capturegraph.active:=true;
  if setcapturesource(cboxSources.Text) then
  if buildpreviewgraph(preview as IbaseFilter)then begin
    if cbmute.checked then capturegraph.Volume:=0 else capturegraph.Volume:=10000;
    result:=true;
  end;
except
end;//except
end;//with
end;

{-----------------------------------------------------------------------------}
function TForm1.actualiserListe:Boolean;
begin
result:=False;
with capturemodule do begin
try
  if not GetCaptureSources(cboxSources.items) then  exit;
  if cboxSources.Items.count>0 then begin
      cboxSources.ItemIndex:=0;
      cboxSources.Text:=cboxSources.Items[0];
      result:=true;
  end;
except
end;//try except
end;//with
end;

{-----------------------------------------------------------------------------}
function TForm1.startcapture:Boolean;
begin
result:=false;
with capturemodule do begin
try
  capturegraph.ClearGraph;
  if capturegraph.active=false then capturegraph.Active:=true;
  if rgtype.itemindex=0 then begin
    if not buildDV1graph(preview as IBaseFilter,fichier)then exit;
  end else begin
    if not buildDV2graph(preview as IbaseFilter,fichier) then exit;
    end;
  if cbmute.checked then capturegraph.Volume:=0 else capturegraph.Volume:=10000;
  rgtype.enabled:=false;
  cboxsources.enabled:=false;
  actualiserbtn.enabled:=false;
  capturebtn.enabled:=false;
  stopbtn.enabled:=true;
  capturegraph.Play;
  result:=true;
except
end;//try except
end;//with
end;

{-----------------------------------------------------------------------------}
function TForm1.stopcapture:Boolean;
begin
result:=false;
try
  capturemodule.DVSplitter.filtergraph:=nil;
  capturemodule.capturegraph.stop;
  rgtype.enabled:=true;
  cboxsources.enabled:=true;
  actualiserbtn.enabled:=true;
  capturebtn.enabled:=true;
  stopbtn.enabled:=false;
  result:=previsualiser;
except
end;//try except
end;

{-----------------------------------------------------------------------------}
procedure TForm1.cbMuteClick(Sender: TObject);
begin
if cbMute.Checked then capturemodule.CaptureGraph.Volume:=0 else capturemodule.capturegraph.Volume:=10000;
end;

{-----------------------------------------------------------------------------}
end.
